/************************************************************************
 *									*
 *		ʐMvO@x|sdql				*
 *									*
 *				: wlncdlM		*
 *		t@C	: xmodem.c				*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include <stdio.h>
#include "rs232c.h"
#include "yterm.h"

#define	ST_END		0
#define	ST_ERR		-1
#define	ST_ABORT	-2
#define	ST_1		1
#define	ST_2		2
#define	ST_3		3
#define	SOH		0x01
#define	EOT		0x04
#define	ACK		0x06
#define	NAK		0x15
#define	CAN		0x18
#define	TIMEOUT		0x101
#define	ABORT		0x102

/*	֐	*/
static	int s_start(void);
static	int s_st1(int);
static	int s_st2(int);
static	int s_st3(int);
static	int send_dat(void);
static	int r_start(void);
static	int r_st1(int);
static	int r_st2(int);
static	int rcv_dat(void);
static	int event(void);

/*	ϐ	*/
static	u_int	blkno;
static	FILE	*sfp;
static	WINDOW	*swp;
static	u_char	rcv_buf[132];
static	int	retry_counter;
static	int	rcv_counter;
static	long	save_fp;

/*=======================================================================
 |
 |		t@CM
 |
 |	int	x_send(fp, wp)
 |
 |		FILE	*fp;		t@C|C^
 |		WINDOW	*wp;		EBhE|C^
 |
 |		Ԓl			@OFI
 |					|PFMs
 |					|QF~
 |
 =======================================================================*/
int	x_send(FILE *fp, WINDOW *wp)
{
	int	st, ev;

	sfp = fp;		/* Mt@C|C^ۑ */
	swp = wp;		/* EBhE|C^ۑ */
	rs1_flow(FLOW_NONE);	/* t[䖳 */
	rs1_clear();		/* Mobt@NA */

	st = s_start();		/* MJn */
	while (st > 0) {
		ev = event();	/* Cxg҂ */
		switch (st) {
		case ST_1:
			st = s_st1(ev);
			break;
		case ST_2:
			st = s_st2(ev);
			break;
		case ST_3:
			st = s_st3(ev);
			break;
		}
	}
	tm_stop(0);		/* ^C}[~ */

	if (cprm.xon)
		rs1_flow(FLOW_SOFT);	/* t[ݒ */

	return(st);
}

/*=======================================================================
 |
 |		t@CMJn
 |
 |	int	s_start()
 |
 |		Ԓl			rsQP
 |
 =======================================================================*/
static	int	s_start(void)
{
	tm_set(0, 6000);		/* m`j҂^C}[Zbg */
	blkno = 0;			/* ubNԍNA */

	return(ST_1);
}

/*=======================================================================
 |
 |		m`jiMvj҂
 |
 |	int	s_st1(ev)
 |
 |		int	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	int	s_st1(int ev)
{
	int	st;

	st = ST_1;
	switch (ev) {
	case NAK:
		blkno++;	/* ubNԍXV */
		if (send_dat() != EOF) {	/* f[^ubNM */
			tm_set(0, 6000);	/* `bj҂^C}[Zbg */
			st = ST_2;
		} else {
			/* MI */
			rs1_putc(EOT);		/* dnsM */
			st = ST_3;
		}
		break;
	case CAN:
		st = ST_ERR;
		break;
	case TIMEOUT:
		st = ST_ERR;
		break;
	case ABORT:
		st = ST_ABORT;
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		f[^ubNM`bj҂
 |
 |	int	s_st2(ev)
 |
 |		int	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	int	s_st2(int ev)
{
	int	st;

	st = ST_2;
	switch(ev) {
	case ACK:
		blkno++;	/* ubNԍXV */
		if (send_dat() != EOF) {	/* f[^ubNM */
			tm_set(0, 6000);	/* `bj҂^C}[Zbg */
			st = ST_2;
		} else {
			/* MI */
			rs1_putc(EOT);		/* dnsM */
			st = ST_3;
		}
		break;
	case NAK:
		fseek(sfp, save_fp, SEEK_SET);	/* t@Cʒu߂ */
		send_dat();			/* f[^ubNM */
		tm_set(0, 6000);		/* `bj҂^C}[Zbg */
		st = ST_2;
		break;
	case CAN:
		st = ST_ERR;
		break;
	case TIMEOUT:
		st = ST_ERR;
		break;
	case ABORT:
		st = ST_ABORT;
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		dnsM`bj҂
 |
 |	int	s_st3(ev)
 |
 |		int	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	int	s_st3(int ev)
{
	int	st;

	st = ST_3;
	switch (ev) {
	case ACK:
		st = ST_END;
		break;
	case NAK:
		rs1_putc(EOT);
		tm_set(0, 6000);	/* `bj҂^C}[Zbg */
		break;
	case CAN:
		st = ST_ERR;
		break;
	case TIMEOUT:
		st = ST_ERR;
		break;
	case ABORT:
		st = ST_ABORT;
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		f[^ubNM
 |
 |	int	send_dat()
 |
 |		Ԓl			OFM
 |					dneFMI
 |
 =======================================================================*/
static	int	send_dat(void)
{
	int	c, i;
	u_char	sum;

	/* t@C|C^Z[u */
	save_fp = ftell(sfp);

	/* t@CI`FbN */
	if ((c = fgetc(sfp)) == EOF)
		return(EOF);

	w_printf(swp, 21, 6, swp->color, "%u", blkno);	/* ubNԍ\ */
	rs1_putc(SOH);		/* rngM */
	rs1_putc(blkno);		/* ubNԍM */
	rs1_putc(~blkno);	/* ]ubNԍM */
	rs1_putc(c);		/* f[^̂PoCgڑM */
	sum = c;		/* `FbNTNA */
	for (i = 0; i < 127; i++) {
		c = fgetc(sfp);	/* f[^ǂݍ */
		if (c == EOF)
			c = 0x1a;
		rs1_putc(c);	/* f[^M */
		sum += c;	/* `FbNTvZ */
	}
	rs1_putc(sum);		/* `FbNTM */

	return(0);
}

/*=======================================================================
 |
 |		t@CM
 |
 |	int	x_receive(fp, wp)
 |
 |		FILE	*fp;		t@C|C^
 |		WINDOW	*wp;		EBhE|C^
 |
 |		Ԓl			@OFI
 |					|PFMs
 |					|QF~
 |
 =======================================================================*/
int	x_receive(FILE *fp, WINDOW *wp)
{
	int	st, ev;

	sfp = fp;		/* Mt@C|C^ۑ */
	swp = wp;		/* EBhE|C^ۑ */
	rs1_flow(FLOW_NONE);	/* t[䖳 */
	rs1_clear();		/* Mobt@NA */

	st = r_start();		/* MJn */
	while (st > 0) {
		ev = event();	/* Cxg҂ */
		switch (st) {
		case ST_1:
			st = r_st1(ev);
			break;
		case ST_2:
			st = r_st2(ev);
			break;
		}
	}
	tm_stop(0);		/* ^C}[~ */

	if (cprm.xon)
		rs1_flow(FLOW_SOFT);	/* t[ݒ */

	return(st);
}

/*=======================================================================
 |
 |		t@CMJn
 |
 |	int	r_start()
 |
 |		Ԓl			rsQP
 |
 =======================================================================*/
static	int	r_start(void)
{
	rs1_putc(NAK);			/* m`jiMvjM */
	tm_set(0, 1000);		/* rng҂^C}[Zbg */
	retry_counter = 0;		/* gCJE^NA */
	blkno = 0;			/* ubNԍNA */
	return(ST_1);
}

/*=======================================================================
 |
 |		rngM҂
 |
 |	int	r_st1(ev)
 |
 |		int	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	int	r_st1(int ev)
{
	int	st;

	st = ST_1;
	switch (ev) {
	case SOH:
		rcv_buf[0] = ev;	/* rngZ[u */
		rcv_counter = 1;	/* MJE^Zbg */
		tm_set(0, 100);		/* ԃ^C}[Zbg */
		st = ST_2;
		break;
	case EOT:
		rs1_putc(ACK);		/* `bjM */
		st = ST_END;
		break;
	case TIMEOUT:
		if (++retry_counter <= 10) {	/* gC`FbN */
			rs1_putc(NAK);	/* m`jM */
			tm_set(0, 1000);	/* rng҂^C}[Zbg */
		} else {
			/* gCI[o */
			rs1_putc(CAN);	/* b`mM */
			st = ST_ERR;
		}
		break;
	case ABORT:
		rs1_putc(CAN);	/* b`mM */
		st = ST_ABORT;
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		f[^ubNM҂
 |
 |	int	r_st2(ev)
 |
 |		int	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	int	r_st2(int ev)
{
	int	st;

	st = ST_2;
	switch (ev) {
	case TIMEOUT:
		if (++retry_counter <= 10) {	/* gC`FbN */
			rs1_putc(NAK);		/* m`jM */
			tm_set(0, 1000);	/* rng҂^C}[Zbg */
			st = ST_1;
		} else {
			rs1_putc(CAN);		/* b`mM */
			st = ST_ERR;
		}
		break;
	case ABORT:
		rs1_putc(CAN);			/* b`mM */
		st = ST_ABORT;
		break;
	default:
		if (ev <= 0xff) {
			rcv_buf[rcv_counter++] = ev;	/* Mf[^Z[u */
			if (rcv_counter == 132) {
				/* PubNMI */
				if (rcv_dat() == 0) {
					/* Mf[^͐ */
					rs1_putc(ACK);
					tm_set(0, 1000);
					retry_counter = 0;
					st = ST_1;
				} else {
					/* Mf[^ɃG[L */
					if (++retry_counter <= 10) {
						rs1_putc(NAK);
						tm_set(0, 1000);
						st = ST_1;
					} else {
						rs1_putc(CAN);
						st = ST_ERR;
					}
				}
			} else
				tm_set(0, 100);	/* ϰ */
		}
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		f[^ubNM
 |
 |	int	rcv_dat()
 |
 |		Ԓl			OFubN
 |					PFُubN
 |
 =======================================================================*/
static	int	rcv_dat(void)
{
	u_char	sum;
	int	i;

	/* ubNԍ`FbN */
	if (rcv_buf[1] != (u_char)~rcv_buf[2])
		return(1);

	/* `FbNT`FbN */
	sum = 0;
	for (i = 0; i < 128; i++)
		sum += rcv_buf[3+i];
	if (sum != rcv_buf[131])
		return(1);

	/* ubNԍV[PX`FbN */
	if (rcv_buf[1] == (u_char)blkno)
		;
	else if (rcv_buf[1] == (u_char)(blkno + 1)) {
		fwrite(rcv_buf + 3, 128, 1, sfp);
		blkno++;
	} else
		return(1);

	/* MubNԍ\ */
	w_printf(swp, 21, 6, swp->color, "%u", blkno);

	return(0);
}

/*=======================================================================
 |
 |		Cxg҂
 |
 |	int	event()
 |
 |		Ԓl			Cxg
 |
 =======================================================================*/
static	int	event(void)
{
	int	ev, ch;

	for (;;) {
		if (tm_check(0)) {
			ev = TIMEOUT;
			break;
		} else if (rs1_rxc()) {
			ev = (u_char)rs1_get();
			break;
		} else if (ch = inkey()) {
			if (ch == KEY_ESC || ch == KEY_F9) {
				ev = ABORT;
				break;
			}
		}
	}

	return(ev);
}
